/*
 * TemplateJDialog.java
 *
 * Created on 1 octobre 2008, 08:26
 */

package org.cocktail.kiwi.client.nibctrl;

import java.awt.BorderLayout;
import java.awt.Color;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.kiwi.client.metier.EOIndividu;
import org.cocktail.kiwi.client.metier.EOKiwiSignataireService;
import org.cocktail.kiwi.common.utilities.CRITreeView;

import com.webobjects.eoapplication.client.EOClientResourceBundle;
import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class SignatairesServicesView extends javax.swing.JDialog {

	
	protected EODisplayGroup eodOm, eodEtat, eodStructure;
	protected ZEOTable myEOTableOm;
	protected ZEOTableModel myTableModelOm;
	protected TableSorter myTableSorterOm;

    
    /** Creates new form TemplateJDialog */
    public SignatairesServicesView(EODisplayGroup displayGroup1, EODisplayGroup displayGroup2, EODisplayGroup eod3) {
    	
        eodOm = displayGroup1;
        eodEtat = displayGroup2;
        eodStructure = eod3;
        
        initComponents();
        initGui();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewStructures = new CRITreeView();
        buttonClose = new javax.swing.JButton();
        viewSignatairesOM = new javax.swing.JPanel();
        btnAddSignOm = new javax.swing.JButton();
        btnDelSignOm = new javax.swing.JButton();
        btnInit = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Signataires Services");

        viewStructures.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        viewStructures.setLayout(new java.awt.BorderLayout());

        buttonClose.setText("Fermer");
        buttonClose.setIconTextGap(2);
        buttonClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCloseActionPerformed(evt);
            }
        });

        viewSignatairesOM.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        viewSignatairesOM.setLayout(new java.awt.BorderLayout());

        btnInit.setText("Initialiser / Annuaire");
        btnInit.setIconTextGap(2);
        btnInit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnInitActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(viewStructures, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 468, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewSignatairesOM, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 314, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(btnDelSignOm, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(btnAddSignOm, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(4, 4, 4))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(btnInit, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 203, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 505, Short.MAX_VALUE)
                        .add(buttonClose, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(viewStructures, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 559, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .add(29, 29, 29)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(viewSignatairesOM, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 250, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(layout.createSequentialGroup()
                                .add(btnAddSignOm, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(btnDelSignOm, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(buttonClose, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnInit))
                .addContainerGap())
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-854)/2, (screenSize.height-649)/2, 854, 649);
    }// </editor-fold>//GEN-END:initComponents

private void buttonCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCloseActionPerformed

    dispose();
    
}//GEN-LAST:event_buttonCloseActionPerformed

private void btnInitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnInitActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_btnInitActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                SignatairesServicesView dialog = new SignatairesServicesView(null, null, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JButton btnAddSignOm;
    protected javax.swing.JButton btnDelSignOm;
    private javax.swing.JButton btnInit;
    private javax.swing.JButton buttonClose;
    private javax.swing.JPanel viewSignatairesOM;
    private CRITreeView viewStructures;
    // End of variables declaration//GEN-END:variables

    public ZEOTable getMyEOTableOm() {
		return myEOTableOm;
	}

	public void setMyEOTableOm(ZEOTable myEOTable) {
		this.myEOTableOm = myEOTable;
	}

	
	
	public EODisplayGroup getEodOm() {
		return eodOm;
	}

	public void setEodOm(EODisplayGroup eodOm) {
		this.eodOm = eodOm;
	}

	public EODisplayGroup getEodEtat() {
		return eodEtat;
	}

	public void setEodEtat(EODisplayGroup eodEtat) {
		this.eodEtat = eodEtat;
	}

	public ZEOTableModel getMyTableModelOm() {
		return myTableModelOm;
	}

	public void setMyTableModelOm(ZEOTableModel myTableModelOm) {
		this.myTableModelOm = myTableModelOm;
	}


	public javax.swing.JButton getBtnAddSignOm() {
		return btnAddSignOm;
	}

	public void setBtnAddSignOm(javax.swing.JButton btnAddSignOm) {
		this.btnAddSignOm = btnAddSignOm;
	}

	public javax.swing.JButton getBtnDelSignOm() {
		return btnDelSignOm;
	}

	public void setBtnDelSignOm(javax.swing.JButton btnDelSignOm) {
		this.btnDelSignOm = btnDelSignOm;
	}

	public javax.swing.JPanel getViewSignatairesOM() {
		return viewSignatairesOM;
	}

	public void setViewSignatairesOM(javax.swing.JPanel viewSignatairesOM) {
		this.viewSignatairesOM = viewSignatairesOM;
	}

	public CRITreeView getViewStructures() {
		return viewStructures;
	}

	public void setViewStructures(CRITreeView viewStructures) {
		this.viewStructures = viewStructures;
	}
       
	public javax.swing.JButton getBtnInit() {
		return btnInit;
	}

	public void setBtnInit(javax.swing.JButton btnInit) {
		this.btnInit = btnInit;
	}

	private void initGui() {
        
    	EOClientResourceBundle resourceBundle = new EOClientResourceBundle();
    	
    	btnAddSignOm.setIcon((ImageIcon)resourceBundle.getObject("cktl_add_16"));
    	btnDelSignOm.setIcon((ImageIcon)resourceBundle.getObject("cktl_delete_16"));
        btnInit.setIcon((ImageIcon)resourceBundle.getObject("cktl_coche_16"));
        buttonClose.setIcon((ImageIcon)resourceBundle.getObject("cktl_close_16"));
        
        // Signataires des Ordres de Mission
        
        Vector myCols = new Vector();

    	ZEOTableModelColumn	col = new ZEOTableModelColumn(eodOm, EOKiwiSignataireService.INDIVIDU_KEY+"."+EOIndividu.NOM_USUEL_KEY, "Nom", 150);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodOm, EOKiwiSignataireService.INDIVIDU_KEY+"."+EOIndividu.PRENOM_KEY, "Prénom", 150);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);


		myTableModelOm = new ZEOTableModel(eodOm, myCols);
		myTableSorterOm = new TableSorter(myTableModelOm);

		myEOTableOm = new ZEOTable(myTableSorterOm);
		//myEOTable.addListener(myListenerContrat);
		myTableSorterOm.setTableHeader(myEOTableOm.getTableHeader());		

		myEOTableOm.setBackground(new Color(230, 230, 230));
		myEOTableOm.setSelectionBackground(new Color(127,155,165));
		myEOTableOm.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewSignatairesOM.setLayout(new BorderLayout());
		viewSignatairesOM.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewSignatairesOM.removeAll();
		viewSignatairesOM.add(new JScrollPane(myEOTableOm), BorderLayout.CENTER);
		
    }
}
